// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from smacc2_msgs:msg/SmaccSMCommand.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_SM_COMMAND__STRUCT_HPP_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_SM_COMMAND__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__smacc2_msgs__msg__SmaccSMCommand __attribute__((deprecated))
#else
# define DEPRECATED__smacc2_msgs__msg__SmaccSMCommand __declspec(deprecated)
#endif

namespace smacc2_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SmaccSMCommand_
{
  using Type = SmaccSMCommand_<ContainerAllocator>;

  explicit SmaccSMCommand_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->command = 0;
    }
  }

  explicit SmaccSMCommand_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->command = 0;
    }
  }

  // field types and members
  using _command_type =
    int8_t;
  _command_type command;

  // setters for named parameter idiom
  Type & set__command(
    const int8_t & _arg)
  {
    this->command = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t SM_STOP =
    0;
  static constexpr int8_t E_STOP =
    0;
  static constexpr int8_t SM_RESET =
    1;

  // pointer types
  using RawPtr =
    smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__smacc2_msgs__msg__SmaccSMCommand
    std::shared_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__smacc2_msgs__msg__SmaccSMCommand
    std::shared_ptr<smacc2_msgs::msg::SmaccSMCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SmaccSMCommand_ & other) const
  {
    if (this->command != other.command) {
      return false;
    }
    return true;
  }
  bool operator!=(const SmaccSMCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SmaccSMCommand_

// alias to use template instance with default allocator
using SmaccSMCommand =
  smacc2_msgs::msg::SmaccSMCommand_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int8_t SmaccSMCommand_<ContainerAllocator>::SM_STOP;
template<typename ContainerAllocator>
constexpr int8_t SmaccSMCommand_<ContainerAllocator>::E_STOP;
template<typename ContainerAllocator>
constexpr int8_t SmaccSMCommand_<ContainerAllocator>::SM_RESET;

}  // namespace msg

}  // namespace smacc2_msgs

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_SM_COMMAND__STRUCT_HPP_
