// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccOrthogonal.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_orthogonal__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `client_behavior_names`
// Member `client_names`
#include "rosidl_runtime_c/string_functions.h"

bool
smacc2_msgs__msg__SmaccOrthogonal__init(smacc2_msgs__msg__SmaccOrthogonal * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    smacc2_msgs__msg__SmaccOrthogonal__fini(msg);
    return false;
  }
  // client_behavior_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->client_behavior_names, 0)) {
    smacc2_msgs__msg__SmaccOrthogonal__fini(msg);
    return false;
  }
  // client_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->client_names, 0)) {
    smacc2_msgs__msg__SmaccOrthogonal__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccOrthogonal__fini(smacc2_msgs__msg__SmaccOrthogonal * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // client_behavior_names
  rosidl_runtime_c__String__Sequence__fini(&msg->client_behavior_names);
  // client_names
  rosidl_runtime_c__String__Sequence__fini(&msg->client_names);
}

bool
smacc2_msgs__msg__SmaccOrthogonal__are_equal(const smacc2_msgs__msg__SmaccOrthogonal * lhs, const smacc2_msgs__msg__SmaccOrthogonal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // client_behavior_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->client_behavior_names), &(rhs->client_behavior_names)))
  {
    return false;
  }
  // client_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->client_names), &(rhs->client_names)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccOrthogonal__copy(
  const smacc2_msgs__msg__SmaccOrthogonal * input,
  smacc2_msgs__msg__SmaccOrthogonal * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // client_behavior_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->client_behavior_names), &(output->client_behavior_names)))
  {
    return false;
  }
  // client_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->client_names), &(output->client_names)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccOrthogonal *
smacc2_msgs__msg__SmaccOrthogonal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccOrthogonal * msg = (smacc2_msgs__msg__SmaccOrthogonal *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccOrthogonal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccOrthogonal));
  bool success = smacc2_msgs__msg__SmaccOrthogonal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccOrthogonal__destroy(smacc2_msgs__msg__SmaccOrthogonal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    smacc2_msgs__msg__SmaccOrthogonal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
smacc2_msgs__msg__SmaccOrthogonal__Sequence__init(smacc2_msgs__msg__SmaccOrthogonal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccOrthogonal * data = NULL;

  if (size) {
    data = (smacc2_msgs__msg__SmaccOrthogonal *)allocator.zero_allocate(size, sizeof(smacc2_msgs__msg__SmaccOrthogonal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccOrthogonal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccOrthogonal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccOrthogonal__Sequence__fini(smacc2_msgs__msg__SmaccOrthogonal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccOrthogonal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccOrthogonal__Sequence *
smacc2_msgs__msg__SmaccOrthogonal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccOrthogonal__Sequence * array = (smacc2_msgs__msg__SmaccOrthogonal__Sequence *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccOrthogonal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccOrthogonal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccOrthogonal__Sequence__destroy(smacc2_msgs__msg__SmaccOrthogonal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    smacc2_msgs__msg__SmaccOrthogonal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
smacc2_msgs__msg__SmaccOrthogonal__Sequence__are_equal(const smacc2_msgs__msg__SmaccOrthogonal__Sequence * lhs, const smacc2_msgs__msg__SmaccOrthogonal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccOrthogonal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccOrthogonal__Sequence__copy(
  const smacc2_msgs__msg__SmaccOrthogonal__Sequence * input,
  smacc2_msgs__msg__SmaccOrthogonal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccOrthogonal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    smacc2_msgs__msg__SmaccOrthogonal * data =
      (smacc2_msgs__msg__SmaccOrthogonal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccOrthogonal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccOrthogonal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccOrthogonal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
